//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Innovated by Bleh!
//
//Version 2.1.  Possible updates include favorite server
//hilighting, server name color removal, and server renaming.
//
//www.blockheadbleh.co.nr
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//-----------------------------------------------------------------
//-------------------Script Information----------------------------
//-----/----------------------------------------------\------------
//-----|All the stuff like this is for coders like you|------------
//-----|who are wondering how the heck I did this.    |------------
//-----|Have fun exploring, and keep coding!  It may  |------------
//-----|take a while to learn if you haven't, but     |------------
//-----|persist, because becoming a coder is really   |------------
//-----|fun, and you help the community!	      |------------
//-----\----------------------------------------------/------------
//-----------------------------------------------------------------
//-----------------------------------------------------------------

//----------------------JoinServerGui.GetServerInfo()----------------------------------------------
//Called when a server is selected.
//Clear stuff, and join the server.
//-------------------------------------------------------------------------------------------------
function JoinServerGui::GetServerInfo(%this){
	if($RippingData)
		return;
	ServPane.setVisible(1);
	%id = JS_serverList.getSelectedId();
	canvas.popdialog(PlayerListGui);
	%index = getField(JS_serverList.getRowTextById(%id),4); 
	if (setServerInfo(%index)) {
		$RippingData = 1;
		$OldName = $Pref::Player::Name;
		$Pref::Player::Name = "DataRipper";
		setServerInfo(%index);
		if($ServerInfo::Address $= $LastRippedAddress)
			return;
		else
		{
			PlayerServerFinderList.clear();
			%conn = new GameConnection(DataRipperConnection);
			%conn.setConnectArgs("DataRipper"); 
			%conn.isDataRipper = 1;
			%conn.setJoinPassword($Client::Password);
			%conn.connect($ServerInfo::Address);
			if($ServChng[$ServerInfo::Address,0] == 1)
				btnSetFav.setText("Clear Favorite");
			else
				btnSetFav.setText("Set Favorite");
			ServerIP.setText("Server IP: "@ServerrawIP($ServerInfo::Address));
			ServerInfoTxt.setText($ServerInfo::Info);
			ServerDedicated.setText("Dedicated Server? "@($ServerInfo::Dedicated? "Yes": "No"));
			ServerCPU.setText("Server CPU Speed: "@$ServerInfo::CPUSpeed@" Mhz");
			ServerInfo.setText("Server Info:");	
			$LastRippedAddress = $ServerInfo::Address;
		}
	}
}
//----------------------ServerRawIP()--------------------------------------------------------------
//For all those privacy freaks that don't want their port
//number shown.  Happy now?
//-------------------------------------------------------------------------------------------------
function ServerRawIP(%rawip){%finalip = getSubStr(%rawip, 3, 20);%portstart = strstr(%finalip ,":");%finalip = getSubStr(%finalip, 0, %portstart);return %finalip;}
//----------------------GameConnection::onConnectRequestTimedOut()---------------------------------
//When it times out, you want it to kill the connection
//and tell you.
//-------------------------------------------------------------------------------------------------
function GameConnection::onConnectRequestTimedOut(%this)
{
	if($RippingData)
		return;
	disconnectedCleanup();
	MessageBoxOK( "TIMED OUT", "Your connection to the server timed out.");
}
//----------------------GameConnection::onConnectRequestRejected()---------------------------------
//Something happened, like you tried to join a server you were
//banned from.  Therefore, we don't want the window to show.
//-------------------------------------------------------------------------------------------------
function GameConnection::onConnectRequestRejected( %this, %msg ) {
	if($RippingData)
		return;
   switch$(%msg)
   {
      case "CR_INVALID_PROTOCOL_VERSION":
         %error = "Incompatible protocol version: Your game version is not compatible with this server.";
      case "CR_INVALID_CONNECT_PACKET":
         %error = "Internal Error: badly formed network packet";
      case "CR_YOUAREBANNED":
         %error = "You are not allowed to play on this server.";
      case "CR_SERVERFULL":
         %error = "This server is full.";
      case "CR_BADVERSION":
         %error = "This Server is running a different Version! Please download the latest RTB Version and Patch at http://rtb.mocheeze.com/";
      case "CHR_PASSWORD":
         // XXX Should put up a password-entry dialog.
         if ($Client::Password $= "")
            MessageBoxOK( "REJECTED", "That server requires a password.");
         else {
            $Client::Password = "";
            MessageBoxOK( "REJECTED", "That password is incorrect.");
         }
         return;
      case "CHR_PROTOCOL":
         %error = "Incompatible protocol version: Your game version is not compatible with this server.";
      case "CHR_CLASSCRC":
         %error = "Incompatible game classes: Your game version is not compatible with this server.";
      case "CHR_INVALID_CHALLENGE_PACKET":
         %error = "Internal Error: Invalid server response packet";
      default:
         %error = "Connection error.  Please try another server.  Error code: (" @ %msg @ ")";
   }
   disconnectedCleanup();
   MessageBoxOK( "REJECTED", %error);
}
//----------------------killDataRipperConnection()-------------------------------------------------
//Stop the connection, and open the appropriate GUI's.
//JoinServerGui is told to not refresh too.
//-------------------------------------------------------------------------------------------------
function killdataripperconnection()
{
	if(isObject(DataRipperConnection))
		DataRipperConnection.delete();
	DataRipperCleanup();
	$JustRippedData = 1;
	$JustRippedData = 0;
	schedule(5,0,DRcleardelay);
	$Pref::Player::Name = $OldName;
}
//----------------------DRClearDelay()-------------------------------------------------------------
//For some reason, if you select too many servers too fast,
//it crashes your game.  Just adds a delay to decrease the
//chances of it happening.
//-------------------------------------------------------------------------------------------------
function DRcleardelay(){$RippingData = 0;}
//----------------------DataRipperCleanup()--------------------------------------------------------
//Basically do everything a disconnect does, except a few things.
//Its one way.  When its run, its all cleared.
//-------------------------------------------------------------------------------------------------
function DataRipperCleanup()
{
   alxStopAll();
   if (isObject(MusicPlayer))
      MusicPlayer.stop();
   LagIcon.setVisible(false);
   $Pref::Server::TotalTeams = 0;
   clientCmdclearBottomPrint();
   clientCmdClearCenterPrint();
   clearTextureHolds();
   purgeResources();
}
//----------------------PlayerListGui::update()----------------------------------------------------
//Add the players to the list!
//-------------------------------------------------------------------------------------------------
function PlayerListGui::update(%this,%clientId,%name,%isSuperAdmin,%isAdmin,%isAI,%score)
{
   // Build the row to display.  The name can have ML control tags,
   // including color and font.  Since we're not using and
   // ML control here, we need to strip them off.
   if(strstr(%name,"DataRipper") != -1)
   {
	$DRCancel = schedule(100,0,killdataripperconnection);
	return;
   }
   %tag = %isSuperAdmin? "[Super]":
          (%isAdmin? "[Admin]":
          (%isAI? "[Bot]":
          ""));
	if($RippingData)
		%text = StripMLControlChars(%name) SPC %tag;
	else
		%text = StripMLControlChars(%name) SPC %tag TAB %score;

   // Update or add the player to the control
   if (PlayerListGuiList.getRowNumById(%clientId) == -1){
	if($RippingData)
		PlayerServerFinderList.addRow(%clientId, %text);
	else
		PlayerListGuiList.addRow(%clientId, %text);
   }else
      PlayerListGuiList.setRowById(%clientId, %text);

   // Sorts by score
   PlayerListGuiList.sortNumerical(1);

	if($RippingData)
		$DRCancel = schedule(100,0,killdataripperconnection);
}
//----------------------GameConnection::onDrop()---------------------------------------------------
//Get rid of the leave message.
//-------------------------------------------------------------------------------------------------
function GameConnection::onDrop(%client, %reason)
{
	if(%client.connected == 1)
	{
		%client.onClientLeaveGame();

		removeFromServerGuidList( %client.guid );
		//if(strstr(%client.namebase,"DataRipper") != -1)
			messageAllExcept(%client, -1, 'MsgClientDrop', '\c1%1 has left the game.', %client.name, %client);

		removeTaggedString(%client.name);
		$Server::PlayerCount--;

		// Reset the server if everyone has left the game
		if( $Server::PlayerCount == 0 && $Server::Dedicated && $Pref::Server::ResetOnEmpty)
			schedule(0, 0, "resetServerDefaults");
	}	
}
//----------------------SetFavServ()---------------------------------------------------------------
//Function to save and mark servers by IP.
//-------------------------------------------------------------------------------------------------
function SetFavServ()
{
	if($ServChng[$ServerInfo::Address,2] == 1)
		$ServChng[$ServerInfo::Address,2] = 0;
	else
		$ServChng[$ServerInfo::Address,2] = 1;
	JoinServerGui.update();
	export("$ServChng*", "rtb/client/scripts/DataRipperData.cs", False);
	schedule(5,0,fixservdata);
	ServPane.setVisible(0);
}
//----------------------RenameServ()---------------------------------------------------------------
//Function to rename servers.  Exporting is more efficient than openforappend.
//-------------------------------------------------------------------------------------------------
function RenameServ()
{
	$ServChng[$ServerInfo::Address,1] = ServRenameName.getvalue();
	JoinServerGui.update();
	export("$ServChng*", "rtb/client/scripts/DataRipperData.cs", False);
	schedule(5,0,fixservdata);
	ServPane.setVisible(0);
}
//----------------------fixservdata()--------------------------------------------------------------
//Exports can't save arrays, therefore, I've made
//a small script to just add the arrays in.
//-------------------------------------------------------------------------------------------------
function fixservdata()
{
	%dat = new FileObject();
	%dat.openForRead("rtb/client/scripts/DataRipperData.cs");
	while(!%dat.isEOF())
	{
		%dataline[%i] = %dat.readLine();
		%i++;
	}
	%dat.close();
	%file = new FileObject();
	%file.openForWrite("rtb/client/scripts/DataRipperData.cs");
	for(%j = 0;%j <= %i;%j++)
	{
		%dataline[%j] = strreplace(%dataline[%j],"$ServChng","");
		%dataline[%j] = strreplace(%dataline[%j],"_"," ");
		%dataline[%j] = strreplace(%dataline[%j]," =","");
		%dataline[%j] = strreplace(%dataline[%j],";","");
		if(getword(%dataline[%j],2) != 0 || getword(%dataline[%j],2) !$= "")
			%file.writeline(%dataline[%j]);
	}
	%file.close();
}
//----------------------HandleLoadInfoMessage()----------------------------------------------------
//Overwrite the function so that it sets the map.  I know its sent with the query,
//but that doesn't seem to work right.  This way works too.  :P
//-------------------------------------------------------------------------------------------------
function handleLoadInfoMessage( %msgType, %msgString, %mapName ) {
	
	// Need to pop up the loading gui to display this stuff.
   if (!LoadingGui.isAwake() && $RippingData != 1)
   	Canvas.setContent("LoadingGui");

	// Clear all of the loading info lines:
	for( %line = 0; %line < LoadingGui.qLineCount; %line++ )
		LoadingGui.qLine[%line] = "";
	LoadingGui.qLineCount = 0;

	if($RippingData == 1)
	{
		ServerMap.setText("Server Map: "@%mapname);
		return;
	}

	LOAD_MapName.setText( %mapName );

	if(%mapName $= "Green Hills")
	  %mapname = "greenhills";
	if(%mapName $= "The Slopes")
	  %mapname = "slopes";
	if(%mapName $= "Celestial Dreams")
	  %mapname = "celestialdreams";
	if(%mapName $= "Death Valley")
	  %mapname = "deathvalley";
	if(%mapName $= "Lavapit Update")
	  %mapname = "lavapit2";
	if(%mapName $= "Pigs Backyard")
	  %mapname = "pigbackyard";
	if(%mapName $= "RTB Isles")
	  %mapname = "rtbisle";
	if(%mapName $= "The Islands")
	  %mapname = "theislands";
	loadingbitmap.setBitmap("rtb/data/missions/previews/"@%mapName@".png");
}
//----------------------fixservdata()--------------------------------------------------------------
//Read the data.  What else?
//-------------------------------------------------------------------------------------------------
function readserverdata()
{
	%dat = new FileObject();
	%dat.openForRead("rtb/client/scripts/DataRipperData.cs");
	while(!%dat.isEOF())
	{
		%dataline = %dat.readLine();
		if(getword(%dataline,2) != 0 || getword(%dataline,2) !$= "")
			$ServChng[getword(%dataline,0),getword(%dataline,1)] = getword(%dataline,2);
	}
	%dat.close();
}
readserverdata();